Merge pull request #562 from grumpydev/TypeConverterFix
[mono.git] / mono / tests / Makefile.am
1 SUBDIRS = cas assemblyresolve
2
3 check-local: test
4
5 aotcheck: testaot gshared-aot
6
7 TEST_PROG = ../interpreter/mint
8
9 JITTEST_PROG = $(if $(VALGRIND), valgrind $(VALGRIND_ARGS),) $(if $(SGEN),$(top_builddir)/mono/mini/mono-sgen,$(top_builddir)/mono/mini/mono)
10
11 TEST_PROG_RUN = MONO_SHARED_DIR=$(mono_build_root)/runtime MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(TEST_PROG)
12 JITTEST_PROG_RUN = MONO_SHARED_DIR=$(mono_build_root)/runtime MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(JITTEST_PROG)
13
14 RUNTIME_ARGS=--config tests-config --optimize=all --debug
15
16 with_mono_path = MONO_PATH=$(mcs_topdir)/class/lib/net_4_5
17 with_mono_path_moonlight = MONO_PATH=$(mcs_topdir)/class/lib/moonlight_raw
18
19 RUNTIME = $(with_mono_path) $(top_builddir)/runtime/mono-wrapper
20 RUNTIME_MOONLIGHT = $(with_mono_path_moonlight) $(top_builddir)/runtime/mono-wrapper
21
22 MKBUNDLE = \
23         PKG_CONFIG_PATH=$(top_builddir):$(PKG_CONFIG_PATH) \
24         $(RUNTIME) $(mcs_topdir)/class/lib/net_4_5/mkbundle.exe
25
26 MCS = $(RUNTIME) $(mcs_topdir)/class/lib/build/mcs.exe -unsafe -nowarn:0162 -nowarn:0168 -nowarn:0219 -debug
27 ILASM = $(RUNTIME) $(mcs_topdir)/class/lib/net_4_5/ilasm.exe
28
29 BENCHSRC=fib.cs random.cs nested-loops.cs ackermann.cs tight-loop.cs sieve.cs
30
31 STRESS_TESTS_SRC=       \
32         abort-stress-1.cs       \
33         abort-stress-2.cs       \
34         abort-stress-3.cs       \
35         domain-stress.cs        \
36         gchandle-stress.cs      \
37         monitor-stress.cs       \
38         thread-stress.cs        \
39         gc-stress.cs            \
40         exit-stress.cs          \
41         process-stress.cs       \
42         assembly-load-stress.cs
43
44 # Disabled until ?mcs is fixed
45 #       bug-331958.cs
46 BASE_TEST_CS_SRC=               \
47         bug-2907.cs             \
48         array-init.cs           \
49         arraylist.cs            \
50         assemblyresolve_event.cs        \
51         assemblyresolve_event3.cs       \
52         checked.cs              \
53         char-isnumber.cs        \
54         create-instance.cs      \
55         field-layout.cs         \
56         pack-layout.cs          \
57         pack-bug.cs             \
58         hash-table.cs           \
59         test-ops.cs             \
60         obj.cs                  \
61         test-dup-mp.cs          \
62         string.cs               \
63         stringbuilder.cs        \
64         switch.cs               \
65         outparm.cs              \
66         delegate.cs             \
67         bitconverter.cs         \
68         exception.cs            \
69         exception2.cs           \
70         exception3.cs           \
71         exception4.cs           \
72         exception5.cs           \
73         exception6.cs           \
74         exception7.cs           \
75         exception8.cs           \
76         exception10.cs          \
77         exception11.cs          \
78         exception12.cs          \
79         exception13.cs          \
80         exception14.cs          \
81         exception15.cs          \
82         exception16.cs          \
83         exception17.cs          \
84         typeload-unaligned.cs   \
85         struct.cs               \
86         valuetype-gettype.cs    \
87         typeof-ptr.cs           \
88         static-constructor.cs   \
89         pinvoke.cs              \
90         pinvoke2.cs             \
91         pinvoke3.cs             \
92         pinvoke11.cs            \
93         pinvoke13.cs            \
94         pinvoke17.cs            \
95         invoke.cs               \
96         invoke2.cs              \
97         runtime-invoke.cs               \
98         invoke-string-ctors.cs          \
99         reinit.cs               \
100         box.cs                  \
101         array.cs                \
102         enum.cs                 \
103         enum2.cs                \
104         property.cs             \
105         enumcast.cs             \
106         assignable-tests.cs     \
107         array-cast.cs           \
108         array-subtype-attr.cs   \
109         cattr-compile.cs        \
110         cattr-field.cs          \
111         cattr-object.cs         \
112         custom-attr.cs          \
113         double-cast.cs          \
114         newobj-valuetype.cs     \
115         arraylist-clone.cs      \
116         setenv.cs               \
117         vtype.cs                \
118         isvaluetype.cs          \
119         iface6.cs               \
120         iface7.cs               \
121         ipaddress.cs            \
122         array-vt.cs             \
123         interface1.cs           \
124         reflection-enum.cs      \
125         reflection-prop.cs      \
126         reflection4.cs          \
127         reflection5.cs          \
128         reflection-const-field.cs \
129         many-locals.cs          \
130         string-compare.cs       \
131         test-prime.cs           \
132         params.cs               \
133         reflection.cs           \
134         interface.cs            \
135         iface.cs                \
136         iface2.cs               \
137         iface3.cs               \
138         iface4.cs               \
139         iface-large.cs          \
140         virtual-method.cs       \
141         intptrcast.cs           \
142         indexer.cs              \
143         stream.cs               \
144         console.cs              \
145         shift.cs                \
146         jit-int.cs              \
147         jit-uint.cs             \
148         jit-long.cs             \
149         long.cs                 \
150         jit-ulong.cs            \
151         jit-float.cs            \
152         pop.cs                  \
153         time.cs                 \
154         appdomain.cs        \
155         appdomain1.cs           \
156         appdomain2.cs           \
157         appdomain-client.cs     \
158         appdomain-unload.cs \
159         appdomain-async-invoke.cs       \
160         loader.cs       \
161         pointer.cs              \
162         hashcode.cs             \
163         delegate1.cs            \
164         delegate2.cs            \
165         delegate3.cs            \
166         delegate5.cs            \
167         delegate6.cs            \
168         delegate7.cs            \
169         delegate8.cs            \
170         delegate9.cs            \
171         remoting1.cs            \
172         remoting2.cs            \
173         remoting3.cs            \
174         remoting4.cs            \
175         remoting5.cs            \
176         largeexp.cs             \
177         largeexp2.cs            \
178         marshalbyref1.cs        \
179         static-ctor.cs          \
180         inctest.cs              \
181         bound.cs                \
182         array-invoke.cs         \
183         test-arr.cs             \
184         decimal.cs              \
185         decimal-array.cs        \
186         marshal.cs              \
187         marshal1.cs             \
188         marshal2.cs             \
189         marshal3.cs             \
190         marshal5.cs             \
191         marshal6.cs             \
192         marshal7.cs             \
193         marshal8.cs             \
194         marshal9.cs             \
195         marshalbool.cs          \
196         marshal-valuetypes.cs   \
197         test-byval-in-struct.cs \
198         thread.cs               \
199         thread5.cs              \
200         thread6.cs              \
201         thread-static.cs        \
202         thread-static-init.cs   \
203         context-static.cs       \
204         float-pop.cs            \
205         interfacecast.cs        \
206         array3.cs               \
207         classinit.cs            \
208         classinit2.cs           \
209         synchronized.cs         \
210         async_read.cs           \
211         threadpool.cs           \
212         threadpool1.cs          \
213         threadpool-exceptions1.cs \
214         threadpool-exceptions2.cs \
215         threadpool-exceptions3.cs \
216         threadpool-exceptions4.cs \
217         threadpool-exceptions5.cs \
218         threadpool-exceptions6.cs \
219         threadpool-exceptions7.cs \
220         base-definition.cs      \
221         bug-27420.cs            \
222         bug-47295.cs            \
223         bug-46781.cs            \
224         bug-48015.cs            \
225         bug-42136.cs            \
226         bug-59286.cs            \
227         bug-70561.cs            \
228         bug-78311.cs            \
229         bug-78653.cs            \
230         bug-78656.cs            \
231         bug-77127.cs            \
232         bug-323114.cs           \
233         bug-Xamarin-5278.cs     \
234         interlocked.cs          \
235         cross-domain.cs         \
236         appdomain-exit.cs       \
237         delegate-async-exit.cs  \
238         delegate-delegate-exit.cs       \
239         delegate-exit.cs        \
240         finalizer-abort.cs      \
241         finalizer-exception.cs  \
242         finalizer-exit.cs       \
243         finalizer-thread.cs     \
244         main-exit.cs    \
245         main-returns-abort-resetabort.cs        \
246         main-returns-background-abort-resetabort.cs     \
247         main-returns-background-resetabort.cs   \
248         main-returns-background.cs      \
249         main-returns-background-change.cs       \
250         main-returns.cs         \
251         subthread-exit.cs       \
252         desweak.cs              \
253         cominterop.cs           \
254         exists.cs               \
255         handleref.cs    \
256         transparentproxy.cs \
257         dbnull-missing.cs       \
258         test-type-ctor.cs       \
259         soft-float-tests.cs     \
260         thread-exit.cs          \
261         finalize-parent.cs      \
262         assemblyresolve_event2.2.cs     \
263         interlocked-2.2.cs      \
264         pinvoke-2.2.cs          \
265         bug-78431.2.cs          \
266         bug-79684.2.cs          \
267         catch-generics.2.cs     \
268         event-get.2.cs          \
269         safehandle.2.cs         \
270         stackframes-async.2.cs          \
271         module-cctor-loader.2.cs        \
272         generics-invoke-byref.2.cs      \
273         generic-signature-compare.2.cs  \
274         generics-sharing.2.cs   \
275         shared-generic-methods.2.cs     \
276         shared-generic-synchronized.2.cs        \
277         generic-inlining.2.cs   \
278         generic-initobj.2.cs    \
279         generic-delegate.2.cs   \
280         generic-sizeof.2.cs     \
281         generic-virtual.2.cs    \
282         generic-interface-methods.2.cs  \
283         generic-array-type.2.cs \
284         generic-method-patching.2.cs    \
285         generic-static-methods.2.cs     \
286         generic-null-call.2.cs  \
287         generic-special.2.cs    \
288         generic-exceptions.2.cs \
289         generic-virtual2.2.cs   \
290         generic-valuetype-interface.2.cs        \
291         generic-getgenericarguments.2.cs        \
292         generic-type-builder.2.cs       \
293         generic-synchronized.2.cs       \
294         generic-delegate-ctor.2.cs      \
295         generic-array-iface-set.2.cs    \
296         generic-typedef.2.cs    \
297         generic-marshalbyref.2.cs       \
298         generic-xdomain.2.cs    \
299         bug-431413.2.cs \
300         bug-459285.2.cs \
301         generic-virtual-invoke.2.cs     \
302         bug-461198.2.cs \
303         generic-sealed-virtual.2.cs     \
304         generic-system-arrays.2.cs      \
305         generic-stack-traces.2.cs       \
306         generic-stack-traces2.2.cs      \
307         bug-472600.2.cs \
308         recursive-generics.2.cs \
309         bug-473482.2.cs \
310         bug-473999.2.cs \
311         bug-479763.2.cs \
312         bug-616463.cs   \
313         bug-80392.2.cs          \
314         dynamic-method-access.2.cs      \
315         dynamic-method-finalize.2.cs    \
316         bug-82194.2.cs  \
317         anonarray.2.cs  \
318         ienumerator-interfaces.2.cs     \
319         array-enumerator-ifaces.2.cs    \
320         generic_type_definition_encoding.2.cs \
321         generic_type_definition.2.cs    \
322         bug-333798.2.cs         \
323         bug-333798-tb.2.cs              \
324         bug-335131.2.cs         \
325         bug-322722_patch_bx.2.cs                \
326         bug-348522.2.cs         \
327         bug-340662_bug.cs       \
328         bug-322722_dyn_method_throw.2.cs        \
329         bug-389886-2.cs \
330         bug-325283.2.cs \
331         thunks.cs \
332         winx64structs.cs \
333         bug-349190.2.cs \
334         nullable_boxing.2.cs    \
335         valuetype-equals.cs     \
336         custom-modifiers.2.cs   \
337         bug-382986.cs   \
338         test-inline-call-stack.cs       \
339         bug-324535.cs   \
340         modules.cs      \
341         bug-81673.cs    \
342         bug-81691.cs    \
343         bug-80307.cs    \
344         bug-415577.cs   \
345         filter-stack.cs \
346         vararg2.cs      \
347         bug-389886-sre-generic-interface-instances.cs   \
348         bug-461867.cs   \
349         bug-461941.cs   \
350         bug-461261.cs   \
351         bug-400716.cs   \
352         bug-462592.cs   \
353         bug-459094.cs   \
354         generic-unloading.2.cs  \
355         generic-unloading-sub.2.cs      \
356         bug-467456.cs   \
357         appdomain-unload-callback.cs    \
358         bug-508538.cs   \
359         bug-472692.2.cs         \
360         gchandles.cs    \
361         interlocked-3.cs        \
362         interlocked-4.2.cs      \
363         finalizer-wait.cs       \
364         critical-finalizers.cs  \
365         appdomain-thread-abort.cs \
366         xdomain-threads.cs      \
367         w32message.cs   \
368         bug-544446.cs   \
369         gc-altstack.cs  \
370         large-gc-bitmap.cs      \
371         bug-561239.cs   \
372         bug-562150.cs   \
373         bug-575941.cs   \
374         bug-599469.cs   \
375         bug-389886-3.cs \
376         monitor.cs      \
377         dynamic-method-resurrection.cs  \
378         bug-666008.cs   \
379         bug-685908.cs   \
380         sgen-long-vtype.cs      \
381         delegate-invoke.cs      \
382         bug-696593.cs   \
383         bug-705140.cs   \
384         bug-1147.cs     \
385         mono-path.cs    \
386         bug-bxc-795.cs  \
387         bug-3903.cs     \
388         async-with-cb-throws.cs \
389         appdomain-unload-doesnot-raise-pending-events.cs        \
390         bug-6148.cs     \
391         assembly_append_ordering.cs
392
393 TEST_CS_SRC_DIST=       \
394         $(BASE_TEST_CS_SRC)     \
395         async-exc-compilation.cs \
396         filter-stack.cs \
397         finally_guard.cs
398
399 TEST_CS_SRC_GEN = \
400         runtime-invoke.gen.cs \
401         imt_big_iface_test.cs
402
403 if AMD64
404 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs
405 # #651684
406 PLATFORM_DISABLED_TESTS = finally_guard.exe
407 else
408 if X86
409 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs
410 else
411 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN)
412 endif
413 endif
414
415 if IA64
416 TEST_CS_SRC+=async-exc-compilation.cs filter-stack.cs
417 # bug #319249
418 PLATFORM_DISABLED_TESTS=exception17.exe
419 PLATFORM_DISABLED_TESTS+=winx64structs.exe
420 endif
421
422 if X86
423
424 if HOST_WIN32
425 PLATFORM_DISABLED_TESTS=async-exc-compilation.exe finally_guard.exe
426 endif
427
428 endif
429
430 if POWERPC
431 # bug #71274
432 PLATFORM_DISABLED_TESTS=finalizer-abort.exe finalizer-exception.exe finalizer-exit.exe
433 endif
434
435 if ARM
436 PLATFORM_DISABLED_TESTS=filter-stack.exe
437 endif
438
439 if MIPS
440 # monitor.exe is racy
441 PLATFORM_DISABLED_TESTS=filter-stack.exe monitor.exe
442 endif
443
444 if S390x
445 PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe
446 #PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe exception17.exe
447 endif
448
449 # The two finalizer tests only work under sgen
450 # gc-altstack.exe fails under boehm because it has no support for altstack
451 # bug-459094.exe creates an extremely deep directory tree
452 # delegate-invoke.exe depends on 929c6bc9b6d76a273f251e6f5dfacac36e9c38bd which was
453 # reverted.
454 # generic_type_definition.2.exe depends on COMPILER_ACCESS which is no longer supported.
455 DISABLED_TESTS=                 \
456         delegate-async-exception.exe    \
457         bug-348522.2.exe        \
458         finalizer-wait.exe      \
459         critical-finalizers.exe \
460         gc-altstack.exe \
461         bug-459094.exe \
462         delegate-invoke.exe \
463         generic_type_definition.2.exe \
464         $(PLATFORM_DISABLED_TESTS)
465
466 DISABLED_TESTS_WRENCH=  \
467         $(DISABLED_TESTS)       \
468         $(PLATFORM_DISABLED_TESTS_WRENCH)       \
469         main-returns-background-resetabort.exe \
470         main-returns-background-abort-resetabort.exe    \
471         main-returns-background.exe     \
472         thread6.exe     \
473         assemblyresolve_event3.exe \
474         delegate2.exe   \
475         finally_guard.exe       \
476         finalizer-abort.exe     \
477         finalizer-exit.exe      \
478         finalizer-thread.exe \
479         appdomain-async-invoke.exe
480
481 AOT_DISABLED_TESTS=constraints-load.exe
482
483 # These only compile with MS CSC
484 TEST_CSC_SRC=                   \
485         vararg.cs
486
487 TEST_IL_SRC=                    \
488         field-access.il         \
489         method-access.il        \
490         ldftn-access.il         \
491         cpblkTest.il            \
492         vbinterface.il          \
493         calliTest.il            \
494         ckfiniteTest.il         \
495         fault-handler.il                \
496         locallocTest.il         \
497         initblkTest.il          \
498         qt-instance.il          \
499         vararg.il               \
500         bug-29859.il            \
501         bug-78549.il            \
502         static-fields-nonconst.il       \
503         reload-at-bb-end.il     \
504         test-enum-indstoreil.il \
505         filter-bug.il           \
506         even-odd.il             \
507         bug-82022.il    \
508         vt-sync-method.il       \
509         enum_types.il   \
510         invalid-token.il        \
511         call_missing_method.il  \
512         call_missing_class.il   \
513         ldfld_missing_field.il  \
514         ldfld_missing_class.il  \
515         find-method.2.il        \
516         bug-79215.2.il  \
517         bug-79956.2.il  \
518         bug-327438.2.il \
519         bug-387274.2.il \
520         bug-426309.2.il \
521         ldtoken_with_byref_typespec.2.il \
522         resolve_method_bug.2.il \
523         resolve_field_bug.2.il \
524         resolve_type_bug.2.il   \
525         generics-sharing-other-exc.2.il \
526         generic-ldobj.2.il      \
527         generic-mkrefany.2.il   \
528         generic-refanyval.2.il  \
529         generic-ldtoken.2.il    \
530         generic-ldtoken-method.2.il     \
531         generic-ldtoken-field.2.il      \
532         generic-tailcall.2.il   \
533         generic-tailcall2.2.il  \
534         generic-array-exc.2.il  \
535         generic-valuetype-newobj2.2.il  \
536         generic-valuetype-newobj.2.il   \
537         generic-constrained.2.il        \
538         generic-type-load-exception.2.il        \
539         bug-81466.il    \
540         bug457574.il    \
541         bug445361.il    \
542         bug-463303.il   \
543         bug469742.2.il  \
544         bug-528055.il   \
545         constraints-load.il     \
546         array_load_exception.il \
547         bug-481403.il   \
548         interface-with-static-method.il \
549         bug-515884.il   \
550         bug-633291.il   \
551         delegate-with-null-target.il    \
552         bug-318677.il   \
553         gsharing-valuetype-layout.il    \
554         invalid_generic_instantiation.il
555
556
557 # pre-requisite test sources: files that are not test themselves
558 # but that need to be compiled
559 PREREQ_IL_SRC=event-il.il module-cctor.il
560 PREREQ_CS_SRC=
561 PREREQ_IL_DLL_SRC=event-il.il module-cctor.il
562 PREREQ_CS_DLL_SRC=
563
564 PREREQSI_IL=$(PREREQ_IL_SRC:.il=.exe)
565 PREREQSI_CS=$(PREREQ_CS_SRC:.cs=.exe)
566 TESTSI_CS=$(TEST_CS_SRC:.cs=.exe)
567 TESTSI_IL=$(TEST_IL_SRC:.il=.exe)
568 TESTBS=$(BENCHSRC:.cs=.exe)
569 STRESS_TESTS=$(STRESS_TESTS_SRC:.cs=.exe)
570
571 EXTRA_DIST=test-driver $(TEST_CS_SRC_DIST) $(TEST_IL_SRC) \
572         $(BENCHSRC) $(STRESS_TESTS_SRC) stress-runner.pl $(PREREQ_IL_SRC) $(PREREQ_CS_SRC)
573
574 %.exe: %.il
575         $(ILASM) -out:$@ $<
576
577 %.exe: %.cs TestDriver.dll
578         $(MCS) -r:TestDriver.dll -out:$@ $<
579
580 # mkbundle works on ppc, but the pkg-config POC doesn't when run with make test
581 if POWERPC
582 test_platform:
583 else
584 # Can't use mkbundle on win32 since there is no static build there
585 # Can't run test-unhandled-exception on Windows because of all the debug popups...
586 if HOST_WIN32
587 test_platform:
588 else
589 # mkbundle uses the installed mono-2.pc so it won't work if there is no system mono
590 #test_platform: testbundle test-iomap-regression
591 test_platform:  test-iomap-regression
592 endif
593 endif
594
595 if X86
596 if HOST_WIN32
597 else
598 test_platform: test-eglib-remap
599 endif
600 endif
601
602 # Target to precompile the test executables
603 tests: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS) $(GSHARED_TESTS)
604
605 #
606 # Test that no symbols are missed in eglib-remap.h
607 #
608 OK_G_SYMBOLS='g_list\|g_slist\|g_concat_dir_and_file'
609 test-eglib-remap:
610         @echo "Testing eglib remap..."
611         @if which nm > /dev/null; then if nm $(top_builddir)/mono/mini/mono | grep -v $(OK_G_SYMBOLS) | grep 't g_'; then exit 1; else exit 0; fi; fi
612
613 #
614 # Tests that the internals in mono/io-layer/messages.c are ok by triggering the 
615 # code that checks that the table is properly sorted
616 #
617 test-messages: w32message.exe
618         > test_messages.zero
619         $(with_mono_path) $(JITTEST_PROG_RUN) w32message.exe >& w32message.allout && cmp test_messages.zero w32message.allout
620
621 if MOONLIGHT
622 test_2_1 : test-coreclr-security
623 else
624 test_2_1 :
625 endif
626
627 if AMD64
628 test-sgen : sgen-tests
629 else
630 if X86
631 test-sgen : sgen-tests
632 else
633 if ARM
634 test-sgen : sgen-tests
635 else
636 if S390x
637 test-sgen : sgen-regular-tests
638 endif
639 endif
640 endif
641 endif
642
643 test: assemblyresolve/test/asm.dll testjit test-type-load test-generic-sharing test_platform test_2_1 test-messages
644 test-wrench: assemblyresolve/test/asm.dll testjit-wrench test-generic-sharing test-type-load test_platform test_2_1 test-process-exit test-sgen test-messages rm-empty-logs
645
646 # Remove empty .stdout and .stderr files for wrench
647 rm-empty-logs:
648         @echo "Removing empty logs..."
649         @find . '(' -name "*.stdout" -o -name "*.stderr" ')' -empty -exec rm {} \;
650
651 assemblyresolve/test/asm.dll:
652         $(MAKE) -C assemblyresolve prereq
653
654 TestDriver.dll:
655         $(MCS) -target:library -out:$@ $(srcdir)/../mini/TestDriver.cs
656
657 test_cs: $(TEST_PROG) $(TESTSI_CS) libtest.la
658         @failed=0; \
659         passed=0; \
660         for i in $(TESTSI_CS); do       \
661                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' $(RUNTIME_ARGS); \
662                 then \
663                         passed=`expr $${passed} + 1`; \
664                 else \
665                         if [ $$? = 2 ]; then break; fi; \
666                         failed=`expr $${failed} + 1`; \
667                 fi \
668         done; \
669         echo; echo ".cs: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
670
671 test_il: $(TEST_PROG) $(TESTSI_IL) libtest.la
672         @failed=0; \
673         passed=0; \
674         for i in $(TESTSI_IL); do       \
675                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i "$(DISABLED_TESTS)" $(RUNTIME_ARGS); \
676                 then \
677                         passed=`expr $${passed} + 1`; \
678                 else \
679                         if [ $$? = 2 ]; then break; fi; \
680                         failed=`expr $${failed} + 1`; \
681                 fi \
682         done; \
683         echo; echo ".il: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
684
685 testb: $(TEST_PROG) $(TESTBS)
686         for i in $(TESTBS); do  \
687                 $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' $(RUNTIME_ARGS);     \
688         done
689
690 runtest-wrench: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
691         @failed=0; \
692         passed=0; \
693         failed_tests="";\
694         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do        \
695                 rm -f $${i}.so; \
696                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
697                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i '$(DISABLED_TESTS_WRENCH)' $(RUNTIME_ARGS); \
698                 then \
699                         passed=`expr $${passed} + 1`; \
700                 else \
701                         if [ $$? = 2 ]; then break; fi; \
702                         failed=`expr $${failed} + 1`; \
703                         failed_tests="$${failed_tests} $$i"; \
704                 fi \
705         done; \
706         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
707         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
708           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
709
710 runtest-managed-wrench: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
711         @$(RUNTIME) ./test-runner.exe -j a --disabled '$(DISABLED_TESTS_WRENCH)' $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
712
713 testjit-wrench:
714         @if test x$(M) != x; then $(MAKE) runtest-managed-wrench; else $(MAKE) runtest-wrench; fi
715
716 runtest: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
717         @failed=0; \
718         passed=0; \
719         failed_tests="";\
720         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do        \
721                 rm -f $${i}.so; \
722                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
723                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' $(RUNTIME_ARGS); \
724                 then \
725                         passed=`expr $${passed} + 1`; \
726                 else \
727                         if [ $$? = 2 ]; then break; fi; \
728                         failed=`expr $${failed} + 1`; \
729                         failed_tests="$${failed_tests} $$i"; \
730                 fi \
731         done; \
732         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
733         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
734           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
735
736 runtest-managed: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
737         @$(RUNTIME) ./test-runner.exe -j a --disabled '$(DISABLED_TESTS)' $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
738
739 testjit:
740         @if test x$(M) != x; then $(MAKE) runtest-managed; else $(MAKE) runtest; fi
741
742 testaot:
743         @$(MAKE) AOT=1 runtest
744
745 testtrace:
746         @$(MAKE) RUNTIME_ARGS="$${RUNTIME_ARGS} --trace" runtest
747
748 testinterp:
749         @$(MAKE) JITTEST_PROG_RUN="$(TEST_PROG_RUN)" runtest
750
751 testjitspeed: $(JITTEST_PROG) $(TESTBS)
752         for i in $(TESTBS); do  \
753                 echo $$i;       \
754                 time $(JITTEST_PROG) $$i;       \
755         done
756
757 test-iomap-regression: exists.cs
758         @$(MCS) $(srcdir)/exists.cs -out:exists.exe
759         @echo "Testing exists.exe..."
760         @MONO_IOMAP=all $(RUNTIME) exists.exe
761
762 stresstest: $(STRESS_TESTS)
763         @failed=0; \
764         passed=0; \
765         failed_tests="";\
766         for i in $(STRESS_TESTS); do    \
767                 if $(srcdir)/stress-runner.pl $$i ../mini/mono $(RUNTIME_ARGS); \
768                 then \
769                         passed=`expr $${passed} + 1`; \
770                 else \
771                         if [ $$? = 2 ]; then break; fi; \
772                         failed=`expr $${failed} + 1`; \
773                         failed_tests="$${failed_tests} $$i"; \
774                 fi \
775         done; \
776         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
777         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
778           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
779
780 testbundle: console.exe
781         @echo "Testing mkbundle..."
782         @$(MKBUNDLE) --static console.exe > mkbundle.stdout
783         @$(with_mono_path) MONO_CFG_DIR=$(mono_cfg_dir) MONO_SHARED_DIR=$(mono_build_root)/runtime ./a.out >> mkbundle.stdout
784         @- rm -rf a.out
785
786 EXTRA_DIST += load-missing.il t-missing.cs load-exceptions.cs
787 test-type-load: TestDriver.dll
788         @$(ILASM) /dll /output:load-missing.dll $(srcdir)/load-missing.il > /dev/null
789         @$(MCS) -t:library -out:t.dll -d:FOUND $(srcdir)/t-missing.cs
790         @$(MCS) -r:TestDriver.dll -r:load-missing.dll -r:t.dll -out:load-exceptions.exe $(srcdir)/load-exceptions.cs
791         @$(MCS) -t:library -out:t.dll $(srcdir)/t-missing.cs
792         @echo "Testing load-exception.exe..."
793         @$(RUNTIME) load-exceptions.exe > load-exceptions.exe.stdout 2> load-exceptions.exe.stderr
794
795
796 EXTRA_DIST += sgen-bridge.cs sgen-descriptors.cs sgen-gshared-vtype.cs sgen-bridge-major-fragmentation.cs sgen-domain-unload.cs sgen-weakref-stress.cs sgen-cementing-stress.cs sgen-case-23400.cs
797
798 SGEN_TESTS =    \
799         sgen-descriptors.exe    \
800         sgen-gshared-vtype.exe  \
801         sgen-domain-unload.exe  \
802         sgen-weakref-stress.exe \
803         sgen-cementing-stress.exe       \
804         sgen-case-23400.exe
805
806 sgen-regular-tests: $(SGEN_TESTS)
807         @for fn in $+ ; do      \
808                 echo "Testing $$fn ...";        \
809                 MONO_GC_PARAMS=major=marksweep-par MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.1.stdout 2> $$fn.1.stderr || exit 1;     \
810                 MONO_GC_PARAMS=major=marksweep-conc MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.5.stdout 2> $$fn.5.stderr || exit 1;    \
811                 MONO_GC_PARAMS=major=marksweep-conc,minor=split MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.6.stdout 2> $$fn.6.stderr || exit 1;        \
812                 MONO_ENV_OPTIONS="--gc=sgen"                                    $(RUNTIME) $$fn > $$fn.2.stdout 2> $$fn.2.stderr || exit 1;     \
813                 MONO_GC_PARAMS=major=marksweep-par,minor=split MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.3.stdout 2> $$fn.3.stderr || exit 1; \
814                 MONO_GC_PARAMS=minor=split MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.4.stdout 2> $$fn.4.stderr || exit 1; \
815                 MONO_GC_PARAMS=major=marksweep-par,minor=split,alloc-ratio=95 MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.7.stdout 2> $$fn.7.stderr || exit 1;  \
816                 MONO_GC_PARAMS=minor=split,alloc-ratio=95 MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.8.stdout 2> $$fn.8.stderr || exit 1;  \
817                 echo "Test $$fn with ssb remset...";    \
818                 MONO_GC_PARAMS=major=marksweep-par,wbarrier=remset MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.10.stdout 2> $$fn.10.stderr || exit 1;   \
819                 MONO_GC_PARAMS=wbarrier=remset MONO_ENV_OPTIONS="--gc=sgen"               $(RUNTIME) $$fn > $$fn.11.stdout 2> $$fn.11.stderr || exit 1; \
820                 MONO_GC_PARAMS=major=marksweep-par,minor=split,wbarrier=remset MONO_ENV_OPTIONS="--gc=sgen"     $(RUNTIME) $$fn > $$fn.12.stdout 2> $$fn.12.stderr || exit 1;   \
821                 MONO_GC_PARAMS=minor=split,wbarrier=remset MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.13.stdout 2> $$fn.13.tderr || exit 1;        \
822                 MONO_GC_PARAMS=major=marksweep-par,minor=split,alloc-ratio=95,wbarrier=remset MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.14.stdout 2> $$fn.14.stderr || exit 1;        \
823                 MONO_GC_PARAMS=minor=split,alloc-ratio=95,wbarrier=remset MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.15.stdout 2> $$fn.15.stderr || exit 1;        \
824         done
825
826
827 sgen-tests: sgen-regular-tests sgen-bridge.exe sgen-bridge-major-fragmentation.exe
828         @echo "Testing sgen-bridge.exe ...";    \
829         MONO_GC_PARAMS=bridge=Bridge MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) sgen-bridge.exe > sgen-bridge.exe.1.stdout 2> sgen-bridge.exe.1.stderr || exit 1;  \
830         MONO_GC_PARAMS=bridge=Bridge,minor=split MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) sgen-bridge.exe > sgen-bridge.exe.2.stdout 2> sgen-bridge.exe.2.stderr || exit 1;      \
831         echo "Testing sgen-bridge-major-fragmentation.exe ..."; \
832         MONO_GC_PARAMS=bridge=Bridge MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) sgen-bridge-major-fragmentation.exe > sgen-bridge-major-fragmentation.exe.1.stdout 2> sgen-bridge-major-fragmentation.exe.1.stderr || exit 1;      \
833         MONO_GC_PARAMS=bridge=Bridge,minor=split MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) sgen-bridge-major-fragmentation.exe > sgen-bridge-major-fragmentation.exe.2.stdout 2> sgen-bridge-major-fragmentation.exe.2.stderr || exit 1;
834
835
836 # Generated tests for runtime invoke
837 EXTRA_DIST += gen-runtime-invoke.cs
838 runtime-invoke.gen.exe: TestDriver.dll gen-runtime-invoke.exe
839         $(RUNTIME) gen-runtime-invoke.exe > runtime-invoke.gen.cs
840         $(MCS) -out:runtime-invoke.gen.exe -r:TestDriver.dll runtime-invoke.gen.cs
841
842 EXTRA_DIST += make-imt-test.cs
843 imt_big_iface_test.exe: TestDriver.dll make-imt-test.exe
844         $(RUNTIME) make-imt-test.exe > imt_big_iface_test.cs
845         $(MCS) -out:imt_big_iface_test.exe -r:TestDriver.dll imt_big_iface_test.cs
846
847 EXTRA_DIST += test-inline-call-stack-library.cs test-inline-call-stack.cs
848 test-inline-call-stack-library.dll: TestDriver.dll $(srcdir)/test-inline-call-stack-library.cs
849         $(MCS) -t:library -out:test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack-library.cs
850 test-inline-call-stack.exe: TestDriver.dll test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack.cs
851         $(MCS) -r:TestDriver.dll -r:test-inline-call-stack-library.dll -out:test-inline-call-stack.exe $(srcdir)/test-inline-call-stack.cs
852
853 EXTRA_DIST += unhandled-exception-base-configuration.config
854 EXTRA_DIST += unhandled-exception-legacy-configuration.config
855 EXTRA_DIST += appdomain-unload.exe.config
856 EXTRA_DIST += unhandled-exception-test-case.2.cs
857 EXTRA_DIST += unhandled-exception-test-runner.2.cs
858 unhandled-exception-test-case.1.cs: unhandled-exception-test-case.2.cs
859         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case.1.cs
860 unhandled-exception-test-case-legacy.1.cs: unhandled-exception-test-case.1.cs
861         cp unhandled-exception-test-case.1.cs unhandled-exception-test-case-legacy.1.cs
862 unhandled-exception-test-case-legacy.2.cs: unhandled-exception-test-case.2.cs
863         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case-legacy.2.cs
864 unhandled-exception-config_files: unhandled-exception-base-configuration.config unhandled-exception-legacy-configuration.config
865         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.1.exe.config
866         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.2.exe.config
867         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.1.exe.config
868         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.2.exe.config
869 unhandled-exception-test-case.1.exe: unhandled-exception-test-case.1.cs
870         $(MCS) /debug unhandled-exception-test-case.1.cs
871 unhandled-exception-test-case-legacy.1.exe: unhandled-exception-test-case-legacy.1.cs
872         $(MCS) /debug unhandled-exception-test-case-legacy.1.cs
873 unhandled-exception-test-case.2.exe: unhandled-exception-test-case.2.cs
874         $(MCS) /debug unhandled-exception-test-case.2.cs
875 unhandled-exception-test-case-legacy.2.exe: unhandled-exception-test-case-legacy.2.cs
876         $(MCS) /debug unhandled-exception-test-case-legacy.2.cs
877 unhandled-exception-test-runner.2.exe: unhandled-exception-test-runner.2.cs
878         $(MCS) /debug unhandled-exception-test-runner.2.cs
879
880 test-unhandled-exception: unhandled-exception-test-runner.2.exe unhandled-exception-config_files unhandled-exception-test-case.1.exe unhandled-exception-test-case-legacy.1.exe  unhandled-exception-test-case.2.exe unhandled-exception-test-case-legacy.2.exe
881         $(RUNTIME) unhandled-exception-test-runner.2.exe RUNTIME:../mini/mono,GTC:F
882
883 # We use 'test-support-files' to handle an ordering issue between the 'mono/' and 'runtime/' directories
884 bug-80307.exe: $(srcdir)/bug-80307.cs
885         $(MCS) -r:System.Web -out:$@ $(srcdir)/bug-80307.cs
886         cd $(top_builddir)/runtime && $(MAKE) test-support-files
887
888 EXTRA_DIST += bug-81673-interface.cs
889 bug-81673.exe bug-81673-interface.dll: $(srcdir)/bug-81673.cs $(srcdir)/bug-81673-interface.cs
890         $(MCS) -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
891         $(MCS) -out:bug-81673.exe -r:bug-81673-interface.dll $(srcdir)/bug-81673.cs
892         $(MCS) -define:WITH_STOP -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
893
894 EXTRA_DIST += bug-81691-a.cs bug-81691-b.cs
895 bug-81691.exe bug-81691-b.dll: $(srcdir)/bug-81691.cs $(srcdir)/bug-81691-a.cs $(srcdir)/bug-81691-b.cs
896         $(MCS) -target:library -out:bug-81691-a.dll $(srcdir)/bug-81691-a.cs
897         $(MCS) -target:library -out:bug-81691-b.dll -r:bug-81691-a.dll $(srcdir)/bug-81691-b.cs
898         $(MCS) -r:bug-81691-b.dll -out:bug-81691.exe $(srcdir)/bug-81691.cs
899         rm -f bug-81691-a.dll
900 bug-81691.exe: bug-81691-b.dll
901
902 EXTRA_DIST += bug-81466-lib.il
903 bug-81466-lib.dll: bug-81466-lib.il
904         $(ILASM) /dll /output:bug-81466-lib.dll $(srcdir)/bug-81466-lib.il
905 bug-81466.exe: bug-81466.il bug-81466-lib.dll
906         $(ILASM) /exe /output:bug-81466.exe $(srcdir)/bug-81466.il
907
908 EXTRA_DIST += bug-324535-il.il
909 bug-324535-il.dll : bug-324535-il.il
910         $(ILASM) /dll /output:bug-324535-il.dll $(srcdir)/bug-324535-il.il
911 bug-324535.exe : bug-324535.cs bug-324535-il.dll
912         $(MCS) -r:bug-324535-il.dll -out:bug-324535.exe $(srcdir)/bug-324535.cs
913
914 EXTRA_DIST += custom-modifiers.2.cs custom-modifiers-lib.il
915 custom-modifiers-lib.dll: custom-modifiers-lib.il
916         $(ILASM) /dll /output:custom-modifiers-lib.dll $(srcdir)/custom-modifiers-lib.il
917 custom-modifiers.2.exe: custom-modifiers.2.cs custom-modifiers-lib.dll
918         $(MCS) -r:custom-modifiers-lib.dll -out:custom-modifiers.2.exe $(srcdir)/custom-modifiers.2.cs
919
920 EXTRA_DIST += bug-382986-lib.cs
921 bug-382986-lib.dll: bug-382986-lib.cs
922         $(MCS) -target:library -out:$@ $(srcdir)/bug-382986-lib.cs
923 bug-382986.exe: bug-382986.cs bug-382986-lib.dll
924         $(MCS) -out:$@ -r:bug-382986-lib.dll $(srcdir)/bug-382986.cs
925
926 EXTRA_DIST += coreclr-security.cs
927
928 if MOONLIGHT
929 coreclr-security.exe : coreclr-security.cs
930         $(SMCS) -out:coreclr-security.exe $(srcdir)/coreclr-security.cs
931
932 test-coreclr-security : coreclr-security.exe
933         @echo "Testing coreclr-security.exe..."
934         @$(RUNTIME_MOONLIGHT) --security=core-clr-test coreclr-security.exe
935 endif
936
937 EXTRA_DIST += generic-unboxing.2.il
938 generic-unboxing.2.dll : generic-unboxing.2.il
939         $(ILASM) /dll /output:generic-unboxing.2.dll $(srcdir)/generic-unboxing.2.il
940
941 EXTRA_DIST += generic-boxing.2.il
942 generic-boxing.2.dll : generic-boxing.2.il generic-unboxing.2.dll
943         $(ILASM) /dll /output:generic-boxing.2.dll $(srcdir)/generic-boxing.2.il
944
945 EXTRA_DIST += generic-unbox.2.cs
946 generic-unbox.2.exe : generic-unbox.2.cs generic-unboxing.2.dll
947         $(MCS) -r:generic-unboxing.2.dll -out:$@ $(srcdir)/generic-unbox.2.cs
948
949 EXTRA_DIST += generic-box.2.cs
950 generic-box.2.exe : generic-box.2.cs generic-unboxing.2.dll generic-boxing.2.dll
951         $(MCS) -r:generic-unboxing.2.dll,generic-boxing.2.dll -out:$@ $(srcdir)/generic-box.2.cs
952
953 EXTRA_DIST += generic-delegate2.2.cs generic-delegate2-lib.2.il
954 generic-delegate2-lib.2.dll : generic-delegate2-lib.2.il
955         $(ILASM) /dll /output:$@ $(srcdir)/generic-delegate2-lib.2.il
956 generic-delegate2.2.exe : generic-delegate2.2.cs generic-delegate2-lib.2.dll
957         $(MCS) -r:generic-delegate2-lib.2.dll -out:$@ $(srcdir)/generic-delegate2.2.cs
958
959 bug-3903.exe: bug-3903.cs
960         $(MCS) -sdk:2 $(srcdir)/bug-3903.cs -out:$@
961
962 gshared: test-generic-sharing
963
964 gshared-aot:
965         @$(MAKE) AOT=1 gshared
966
967 GSHARED_TESTS = \
968                 generics-sharing.2.exe shared-generic-methods.2.exe     \
969                 shared-generic-synchronized.2.exe generic-initobj.2.exe         \
970                 generics-sharing-other-exc.2.exe generic-box.2.exe              \
971                 generic-unbox.2.exe generic-delegate.2.exe generic-sizeof.2.exe \
972                 generic-ldobj.2.exe generic-mkrefany.2.exe                      \
973                 generic-refanyval.2.exe generic-ldtoken.2.exe                   \
974                 generic-ldtoken-method.2.exe  generic-ldtoken-field.2.exe       \
975                 generic-virtual.2.exe generic-tailcall.2.exe                    \
976                 generic-interface-methods.2.exe generic-array-type.2.exe        \
977                 generic-method-patching.2.exe generic-static-methods.2.exe      \
978                 generic-null-call.2.exe generic-tailcall2.2.exe                 \
979                 generic-array-exc.2.exe generic-special.2.exe                   \
980                 generic-exceptions.2.exe generic-delegate2.2.exe                \
981                 generic-virtual2.2.exe generic-valuetype-interface.2.exe        \
982                 generic-valuetype-newobj.2.exe generic-valuetype-newobj2.2.exe  \
983                 generic-getgenericarguments.2.exe generic-type-builder.2.exe    \
984                 generic-synchronized.2.exe generic-delegate-ctor.2.exe          \
985                 generic-constrained.2.exe bug-431413.2.exe                      \
986                 generic-virtual-invoke.2.exe generic-typedef.2.exe              \
987                 generic-marshalbyref.2.exe bug-459285.2.exe bug-461198.2.exe    \
988                 generic-sealed-virtual.2.exe generic-system-arrays.2.exe        \
989                 generic-stack-traces.2.exe generic-stack-traces2.2.exe          \
990                 bug-472600.2.exe bug-473482.2.exe bug-473999.2.exe              \
991                 bug-479763.2.exe generic-xdomain.2.exe                          \
992                 generic-type-load-exception.2.exe bug-616463.exe        \
993                 bug-1147.exe
994
995 test-generic-sharing-normal: $(GSHARED_TESTS)
996         @for fn in $+ ; do      \
997                 echo "Testing $$fn ...";        \
998                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared                $$fn > $$fn.stdout || exit 1;     \
999                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,shared         $$fn > $$fn.stdout || exit 1;     \
1000                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,-inline        $$fn > $$fn.stdout || exit 1;     \
1001                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,-inline,shared $$fn > $fn.stdout || exit 1;      \
1002                 if [ x$(AOT) = x1 ]; then MONO_GENERIC_SHARING=all $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $$fn > /dev/null || exit 1; MONO_GENERIC_SHARING=all $(RUNTIME) $$fn > $$fn.stdout || exit 1; fi; \
1003         done
1004
1005 test-generic-sharing-managed: test-runner.exe $(GSHARED_TESTS)
1006         @$(RUNTIME) ./test-runner.exe -j a --opt-sets "gshared gshared,shared gshared,-inline gshared,-inline,shared" $(GSHARED_TESTS)
1007
1008 test-generic-sharing:
1009         @if test x$(M) != x; then $(MAKE) test-generic-sharing-managed; else $(MAKE) test-generic-sharing-normal; fi
1010
1011 EXTRA_DIST += async-exceptions.cs
1012 async-exceptions.exe : async-exceptions.cs
1013         $(MCS) -out:async-exceptions.exe $(srcdir)/async-exceptions.cs
1014 test-async-exceptions : async-exceptions.exe
1015         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:foo $$i async-exceptions.exe || exit 1; done
1016         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:bar $$i async-exceptions.exe || exit 1; done
1017
1018 EXTRA_DIST += modules.cs modules-m1.cs
1019 modules-m1.netmodule: modules-m1.cs
1020         $(MCS) -out:$@ /target:module $(srcdir)/modules-m1.cs
1021 modules.exe: modules.cs modules-m1.netmodule TestDriver.dll
1022         $(MCS) -out:$@ /addmodule:modules-m1.netmodule -r:TestDriver.dll $(srcdir)/modules.cs
1023
1024 # Useful if mono is compiled with --enable-shared=no
1025 patch-libtool:
1026         cp "../../libtool" .
1027         sed -e 's,build_libtool_libs=no,build_libtool_libs=yes,g' libtool > 2; mv 2 libtool
1028         sed -e 's,LIBTOOL =,LIBTOOL2 =,g' Makefile > 2 && echo "LIBTOOL = bash ./libtool" > 1 && cat 1 2 > Makefile
1029         touch libtest.c
1030
1031 EXTRA_DIST += bug-438454.cs bug-438454.exe.stdout.expected
1032 test-process-exit:
1033         @$(MCS) $(srcdir)/bug-438454.cs -out:bug-438454.exe
1034         @echo "Testing bug-438454.exe..."
1035         @$(RUNTIME) bug-438454.exe > bug-438454.exe.stdout
1036         @diff -w bug-438454.exe.stdout $(srcdir)/bug-438454.exe.stdout.expected
1037
1038 OOM_TESTS =     \
1039         gc-oom-handling.exe     \
1040         gc-oom-handling2.exe
1041
1042
1043 test-oom: $(OOM_TESTS)
1044         @for fn in $+ ; do      \
1045                 echo "Testing $$fn ...";        \
1046                 MONO_GC_PARAMS=max-heap-size=16m,major=marksweep-par MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1047                 MONO_GC_PARAMS=max-heap-size=16m MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1048                 MONO_GC_PARAMS=max-heap-size=16m                                                  $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1049         done
1050
1051
1052 noinst_LTLIBRARIES = libtest.la
1053
1054 AM_CPPFLAGS = $(GLIB_CFLAGS) $(GMODULE_CFLAGS)
1055
1056 if HOST_WIN32
1057 # gcc-3.4.4 emits incorrect code when making indirect calls to stdcall functions using a tail call
1058 # This shows up when compiling mono_test_marshal_delegate ()
1059 libtest_la_CFLAGS=-fno-optimize-sibling-calls
1060 # the exported names created by gcc for stdcall functions are missing the leading _, so MS.NET
1061 # can't find them. So we use --kill-at to remove the @ suffix as well.
1062 libtest_la_LDFLAGS=-no-undefined -rpath `pwd` -Wl,--kill-at
1063 else
1064 libtest_la_LDFLAGS = -rpath `pwd`
1065 endif
1066 libtest_la_SOURCES = libtest.c
1067 libtest_la_LIBADD = $(GLIB_LIBS) $(LIBICONV)
1068
1069 CLEANFILES = $(TESTSI_CS) $(TESTSI_IL) $(STRESS_TESTS) *.dll *.stdout *.aotlog *.exe stest.dat